#!/bin/bash

# @@@ PROTOCOLS avreg-mon v6.x @@@

# {display} {src} {cmd} {opt}

# L program starting
# L program exiting
# L layout newLayoutNr curLayoutNr|1000 (1000 - if first layout)

# TODO
# L fullscreen on|off camNr
# L camera play|stop|pause|select|alarm

set -e

# exec 2>on-demand.err

# layout to avregd  profiles mapping
#                       0        1        2       3      4       5       6       7       8       9
Layouts2ProfilesMap=( '-w00s' '-w00t' '-w19s' '-w19t' '-w01s' '-w01t' '-w02s' '-w02t' '-w03s' '-w03t' )

log() {
   echo "`date +%H:%M:%S`: on-demain: $@" >&2
}

# основной цикл чтения сообщений о событиях
# обратите внимание, что в этом цикле значения НЕ заключены в какие-либо кавычки
while read display src cmd opt ; do
   # проверяем полученные значения
   if [ -z "$display" -o -z "$src" -o -z "$cmd" ]; then
      exit 2
   fi

   log "$display $src $cmd $opt"

   case "$src" in
      'program')
         echo 'done'
         if [ "$cmd" = 'exiting' ]; then
            break
         fi
         ;;
      'layout')
         lto="$(($cmd))"
         lfrom="$(($opt))"
         pto="${Layouts2ProfilesMap[$lto]}"
         pfrom="${Layouts2ProfilesMap[$lfrom]}"
         # log "++++++++++++++++++++ to [$lto]/[$pto] from [$lfrom]/[$pfrom]"
         if [ -n "$lfrom" -a -n "$pfrom" ]; then
            if ! sudo avreg-service stop "$pfrom" >/dev/null ; then
               echo "stop avregd-$pfrom failed"
               continue
            fi
         fi
         if [ -n "$lto" -a -n "$pto" ]; then
            if ! sudo avreg-service start "$pto" >/dev/null ; then
               echo "start avregd-$pto failed"
               continue
            fi
         fi
         echo "done"
         ;;
      *)
         echo 'done'
         ;;
   esac
done

log "exit"

exit 0
